Index: uspace/lib/c/include/devmap.h
===================================================================
--- uspace/lib/c/include/devmap.h	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/c/include/devmap.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -44,11 +44,11 @@
 
 extern int devmap_driver_register(const char *, async_client_conn_t);
-extern int devmap_device_register(const char *, dev_handle_t *);
+extern int devmap_device_register(const char *, devmap_handle_t *);
 
-extern int devmap_device_get_handle(const char *, dev_handle_t *, unsigned int);
-extern int devmap_namespace_get_handle(const char *, dev_handle_t *, unsigned int);
-extern devmap_handle_type_t devmap_handle_probe(dev_handle_t);
+extern int devmap_device_get_handle(const char *, devmap_handle_t *, unsigned int);
+extern int devmap_namespace_get_handle(const char *, devmap_handle_t *, unsigned int);
+extern devmap_handle_type_t devmap_handle_probe(devmap_handle_t);
 
-extern int devmap_device_connect(dev_handle_t, unsigned int);
+extern int devmap_device_connect(devmap_handle_t, unsigned int);
 
 extern int devmap_null_create(void);
@@ -56,8 +56,8 @@
 
 extern size_t devmap_count_namespaces(void);
-extern size_t devmap_count_devices(dev_handle_t);
+extern size_t devmap_count_devices(devmap_handle_t);
 
 extern size_t devmap_get_namespaces(dev_desc_t **);
-extern size_t devmap_get_devices(dev_handle_t, dev_desc_t **);
+extern size_t devmap_get_devices(devmap_handle_t, dev_desc_t **);
 
 #endif
Index: uspace/lib/c/include/err.h
===================================================================
--- uspace/lib/c/include/err.h	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/c/include/err.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -37,9 +37,4 @@
 
 #include <stdio.h>
-#include <errno.h>
-
-#ifdef CONFIG_DEBUG
-#include <str_error.h>
-#endif
 
 #define errx(status, fmt, ...) { \
@@ -48,54 +43,7 @@
 }
 
-
-/** An actual stored error code.  */
-#define ERROR_CODE  error_check_return_value
-
-/** An error processing routines declaration.
- *
- * This has to be declared in the block where the error processing
- * is desired.
- */
-#define ERROR_DECLARE  int ERROR_CODE
-
-/** Store the value as an error code and checks if an error occurred.
- *
- * @param[in] value	The value to be checked. May be a function call.
- * @return		False if the value indicates success (EOK).
- * @return		True otherwise.
- */
-#ifdef CONFIG_DEBUG
-
-#define ERROR_OCCURRED(value) \
-	(((ERROR_CODE = (value)) != EOK) && \
-	({ \
-		fprintf(stderr, "libsocket error at %s:%d (%s)\n", \
-		__FILE__, __LINE__, str_error(ERROR_CODE)); \
-		1; \
-	}))
-
-#else
-
-#define ERROR_OCCURRED(value)	((ERROR_CODE = (value)) != EOK)
-
-#endif
-
-#define ERROR_NONE(value)	!ERROR_OCCURRED((value))
-
-/** Error propagation
- *
- * Check if an error occurred and immediately exit the actual
- * function returning the error code.
- *
- * @param[in] value	The value to be checked. May be a function call.
- *
- */
-
-#define ERROR_PROPAGATE(value) \
-	if (ERROR_OCCURRED(value)) \
-		return ERROR_CODE
-
 #endif
 
 /** @}
  */
+
Index: uspace/lib/c/include/ipc/devman.h
===================================================================
--- uspace/lib/c/include/ipc/devman.h	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/c/include/ipc/devman.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -42,5 +42,5 @@
 #define DEVMAN_NAME_MAXLEN 256
 
-typedef ipcarg_t device_handle_t;
+typedef ipcarg_t devman_handle_t;
 
 /** Ids of device models used for device-to-driver matching.
Index: uspace/lib/c/include/ipc/devmap.h
===================================================================
--- uspace/lib/c/include/ipc/devmap.h	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/c/include/ipc/devmap.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -40,5 +40,5 @@
 #define DEVMAP_NAME_MAXLEN  255
 
-typedef ipcarg_t dev_handle_t;
+typedef ipcarg_t devmap_handle_t;
 
 typedef enum {
@@ -81,5 +81,5 @@
 
 typedef struct {
-	dev_handle_t handle;
+	devmap_handle_t handle;
 	char name[DEVMAP_NAME_MAXLEN + 1];
 } dev_desc_t;
Index: uspace/lib/c/include/stdio.h
===================================================================
--- uspace/lib/c/include/stdio.h	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/c/include/stdio.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -46,5 +46,5 @@
 #define BUFSIZ  4096
 
-#define DEBUG(fmt, ...)se\
+#define DEBUG(fmt, ...) \
 	{ \
 		char _buf[256]; \
Index: uspace/lib/c/include/sys/stat.h
===================================================================
--- uspace/lib/c/include/sys/stat.h	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/c/include/sys/stat.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -43,5 +43,5 @@
 struct stat {
 	fs_handle_t fs_handle;
-	dev_handle_t dev_handle;
+	devmap_handle_t devmap_handle;
 	fs_index_t index;
 	unsigned int lnkcnt;
@@ -49,5 +49,5 @@
 	bool is_directory;
 	aoff64_t size;
-	dev_handle_t device;
+	devmap_handle_t device;
 };
 
Index: uspace/lib/c/include/unistd.h
===================================================================
--- uspace/lib/c/include/unistd.h	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/c/include/unistd.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -41,5 +41,5 @@
 
 #ifndef NULL
-	#define NULL  0
+	#define NULL  0UL
 #endif
 
Index: uspace/lib/c/include/vfs/vfs.h
===================================================================
--- uspace/lib/c/include/vfs/vfs.h	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/c/include/vfs/vfs.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -47,5 +47,5 @@
 typedef struct {
 	fs_handle_t fs_handle;
-	dev_handle_t dev_handle;
+	devmap_handle_t devmap_handle;
 	fs_index_t index;
 } fdi_node_t;
Index: uspace/lib/drv/generic/driver.c
===================================================================
--- uspace/lib/drv/generic/driver.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/drv/generic/driver.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -139,5 +139,5 @@
 }
 
-static device_t * driver_get_device(link_t *devices, device_handle_t handle)
+static device_t * driver_get_device(link_t *devices, devman_handle_t handle)
 {
 	device_t *dev = NULL;
@@ -163,5 +163,5 @@
 	int res = EOK;
 	
-	device_handle_t dev_handle =  IPC_GET_ARG1(*icall);
+	devman_handle_t dev_handle =  IPC_GET_ARG1(*icall);
 	device_t *dev = create_device();
 	dev->handle = dev_handle;
@@ -221,5 +221,5 @@
 	 * the device to which the client connected.
 	 */
-	device_handle_t handle = IPC_GET_ARG2(*icall);
+	devman_handle_t handle = IPC_GET_ARG2(*icall);
 	device_t *dev = driver_get_device(&devices, handle);
 
Index: uspace/lib/drv/include/driver.h
===================================================================
--- uspace/lib/drv/include/driver.h	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/drv/include/driver.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -118,5 +118,5 @@
 	 * device manager).
 	 */
-	device_handle_t handle;
+	devman_handle_t handle;
 	
 	/**
Index: uspace/lib/fs/libfs.c
===================================================================
--- uspace/lib/fs/libfs.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/fs/libfs.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -150,8 +150,8 @@
     ipc_call_t *request)
 {
-	dev_handle_t mp_dev_handle = (dev_handle_t) IPC_GET_ARG1(*request);
+	devmap_handle_t mp_devmap_handle = (devmap_handle_t) IPC_GET_ARG1(*request);
 	fs_index_t mp_fs_index = (fs_index_t) IPC_GET_ARG2(*request);
 	fs_handle_t mr_fs_handle = (fs_handle_t) IPC_GET_ARG3(*request);
-	dev_handle_t mr_dev_handle = (dev_handle_t) IPC_GET_ARG4(*request);
+	devmap_handle_t mr_devmap_handle = (devmap_handle_t) IPC_GET_ARG4(*request);
 	int res;
 	ipcarg_t rc;
@@ -174,5 +174,5 @@
 	
 	fs_node_t *fn;
-	res = ops->node_get(&fn, mp_dev_handle, mp_fs_index);
+	res = ops->node_get(&fn, mp_devmap_handle, mp_fs_index);
 	if ((res != EOK) || (!fn)) {
 		ipc_hangup(mountee_phone);
@@ -201,10 +201,10 @@
 	ipc_call_t answer;
 	rc = async_data_write_forward_1_1(mountee_phone, VFS_OUT_MOUNTED,
-	    mr_dev_handle, &answer);
+	    mr_devmap_handle, &answer);
 	
 	if (rc == EOK) {
 		fn->mp_data.mp_active = true;
 		fn->mp_data.fs_handle = mr_fs_handle;
-		fn->mp_data.dev_handle = mr_dev_handle;
+		fn->mp_data.devmap_handle = mr_devmap_handle;
 		fn->mp_data.phone = mountee_phone;
 	}
@@ -219,10 +219,10 @@
 void libfs_unmount(libfs_ops_t *ops, ipc_callid_t rid, ipc_call_t *request)
 {
-	dev_handle_t mp_dev_handle = (dev_handle_t) IPC_GET_ARG1(*request);
+	devmap_handle_t mp_devmap_handle = (devmap_handle_t) IPC_GET_ARG1(*request);
 	fs_index_t mp_fs_index = (fs_index_t) IPC_GET_ARG2(*request);
 	fs_node_t *fn;
 	int res;
 
-	res = ops->node_get(&fn, mp_dev_handle, mp_fs_index);
+	res = ops->node_get(&fn, mp_devmap_handle, mp_fs_index);
 	if ((res != EOK) || (!fn)) {
 		ipc_answer_0(rid, combine_rc(res, ENOENT));
@@ -243,5 +243,5 @@
 	 */
 	res = async_req_1_0(fn->mp_data.phone, VFS_OUT_UNMOUNTED,
-	    fn->mp_data.dev_handle);
+	    fn->mp_data.devmap_handle);
 
 	/*
@@ -252,5 +252,5 @@
 		fn->mp_data.mp_active = false;
 		fn->mp_data.fs_handle = 0;
-		fn->mp_data.dev_handle = 0;
+		fn->mp_data.devmap_handle = 0;
 		fn->mp_data.phone = 0;
 		/* Drop the reference created in libfs_mount(). */
@@ -281,5 +281,5 @@
 	unsigned int last = IPC_GET_ARG2(*request);
 	unsigned int next = first;
-	dev_handle_t dev_handle = IPC_GET_ARG3(*request);
+	devmap_handle_t devmap_handle = IPC_GET_ARG3(*request);
 	int lflag = IPC_GET_ARG4(*request);
 	fs_index_t index = IPC_GET_ARG5(*request);
@@ -295,10 +295,10 @@
 	fs_node_t *tmp = NULL;
 	
-	rc = ops->root_get(&cur, dev_handle);
+	rc = ops->root_get(&cur, devmap_handle);
 	on_error(rc, goto out_with_answer);
 	
 	if (cur->mp_data.mp_active) {
 		ipc_forward_slow(rid, cur->mp_data.phone, VFS_OUT_LOOKUP,
-		    next, last, cur->mp_data.dev_handle, lflag, index,
+		    next, last, cur->mp_data.devmap_handle, lflag, index,
 		    IPC_FF_ROUTE_FROM_ME);
 		(void) ops->node_put(cur);
@@ -358,5 +358,5 @@
 			
 			ipc_forward_slow(rid, tmp->mp_data.phone,
-			    VFS_OUT_LOOKUP, next, last, tmp->mp_data.dev_handle,
+			    VFS_OUT_LOOKUP, next, last, tmp->mp_data.devmap_handle,
 			    lflag, index, IPC_FF_ROUTE_FROM_ME);
 			(void) ops->node_put(cur);
@@ -385,8 +385,8 @@
 				fs_node_t *fn;
 				if (lflag & L_CREATE)
-					rc = ops->create(&fn, dev_handle,
+					rc = ops->create(&fn, devmap_handle,
 					    lflag);
 				else
-					rc = ops->node_get(&fn, dev_handle,
+					rc = ops->node_get(&fn, devmap_handle,
 					    index);
 				on_error(rc, goto out_with_answer);
@@ -401,5 +401,5 @@
 						aoff64_t size = ops->size_get(fn);
 						ipc_answer_5(rid, fs_handle,
-						    dev_handle,
+						    devmap_handle,
 						    ops->index_get(fn),
 						    LOWER32(size),
@@ -469,7 +469,7 @@
 			fs_node_t *fn;
 			if (lflag & L_CREATE)
-				rc = ops->create(&fn, dev_handle, lflag);
+				rc = ops->create(&fn, devmap_handle, lflag);
 			else
-				rc = ops->node_get(&fn, dev_handle, index);
+				rc = ops->node_get(&fn, devmap_handle, index);
 			on_error(rc, goto out_with_answer);
 			
@@ -483,5 +483,5 @@
 					aoff64_t size = ops->size_get(fn);
 					ipc_answer_5(rid, fs_handle,
-					    dev_handle,
+					    devmap_handle,
 					    ops->index_get(fn),
 					    LOWER32(size),
@@ -509,5 +509,5 @@
 		if (rc == EOK) {
 			aoff64_t size = ops->size_get(cur);
-			ipc_answer_5(rid, fs_handle, dev_handle,
+			ipc_answer_5(rid, fs_handle, devmap_handle,
 			    ops->index_get(cur), LOWER32(size), UPPER32(size),
 			    old_lnkcnt);
@@ -547,5 +547,5 @@
 		if (rc == EOK) {
 			aoff64_t size = ops->size_get(cur);
-			ipc_answer_5(rid, fs_handle, dev_handle,
+			ipc_answer_5(rid, fs_handle, devmap_handle,
 			    ops->index_get(cur), LOWER32(size), UPPER32(size),
 			    ops->lnkcnt_get(cur));
@@ -571,9 +571,9 @@
     ipc_call_t *request)
 {
-	dev_handle_t dev_handle = (dev_handle_t) IPC_GET_ARG1(*request);
+	devmap_handle_t devmap_handle = (devmap_handle_t) IPC_GET_ARG1(*request);
 	fs_index_t index = (fs_index_t) IPC_GET_ARG2(*request);
 	
 	fs_node_t *fn;
-	int rc = ops->node_get(&fn, dev_handle, index);
+	int rc = ops->node_get(&fn, devmap_handle, index);
 	on_error(rc, answer_and_return(rid, rc));
 	
@@ -592,5 +592,5 @@
 	
 	stat.fs_handle = fs_handle;
-	stat.dev_handle = dev_handle;
+	stat.devmap_handle = devmap_handle;
 	stat.index = index;
 	stat.lnkcnt = ops->lnkcnt_get(fn);
@@ -617,9 +617,9 @@
     ipc_call_t *request)
 {
-	dev_handle_t dev_handle = IPC_GET_ARG1(*request);
+	devmap_handle_t devmap_handle = IPC_GET_ARG1(*request);
 	fs_index_t index = IPC_GET_ARG2(*request);
 	
 	fs_node_t *fn;
-	int rc = ops->node_get(&fn, dev_handle, index);
+	int rc = ops->node_get(&fn, devmap_handle, index);
 	on_error(rc, answer_and_return(rid, rc));
 	
Index: uspace/lib/fs/libfs.h
===================================================================
--- uspace/lib/fs/libfs.h	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/fs/libfs.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -47,5 +47,5 @@
 	int phone;
 	fs_handle_t fs_handle;
-	dev_handle_t dev_handle;
+	devmap_handle_t devmap_handle;
 } mp_data_t;
 
@@ -61,10 +61,10 @@
 	 * argument holds the output argument.
 	 */
-	int (* root_get)(fs_node_t **, dev_handle_t);
+	int (* root_get)(fs_node_t **, devmap_handle_t);
 	int (* match)(fs_node_t **, fs_node_t *, const char *);
-	int (* node_get)(fs_node_t **, dev_handle_t, fs_index_t);
+	int (* node_get)(fs_node_t **, devmap_handle_t, fs_index_t);
 	int (* node_open)(fs_node_t *);
 	int (* node_put)(fs_node_t *);
-	int (* create)(fs_node_t **, dev_handle_t, int);
+	int (* create)(fs_node_t **, devmap_handle_t, int);
 	int (* destroy)(fs_node_t *);
 	int (* link)(fs_node_t *, fs_node_t *, const char *);
@@ -81,5 +81,5 @@
 	bool (* is_directory)(fs_node_t *);
 	bool (* is_file)(fs_node_t *);
-	dev_handle_t (* device_get)(fs_node_t *);
+	devmap_handle_t (* device_get)(fs_node_t *);
 } libfs_ops_t;
 
Index: uspace/lib/net/adt/module_map.c
===================================================================
--- uspace/lib/net/adt/module_map.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/net/adt/module_map.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -38,5 +38,5 @@
 #include <task.h>
 #include <unistd.h>
-#include <err.h>
+#include <errno.h>
 
 #include <ipc/services.h>
@@ -67,7 +67,6 @@
     connect_module_t connect_module)
 {
-	ERROR_DECLARE;
-
 	module_ref tmp_module;
+	int rc;
 
 	tmp_module = (module_ref) malloc(sizeof(module_t));
@@ -83,8 +82,8 @@
 	tmp_module->connect_module = connect_module;
 
-	if (ERROR_OCCURRED(modules_add(modules, tmp_module->name, 0,
-	    tmp_module))) {
+	rc = modules_add(modules, tmp_module->name, 0, tmp_module);
+	if (rc != EOK) {
 		free(tmp_module);
-		return ERROR_CODE;
+		return rc;
 	}
 	if (module)
Index: uspace/lib/net/generic/packet_remote.c
===================================================================
--- uspace/lib/net/generic/packet_remote.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/net/generic/packet_remote.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -38,5 +38,4 @@
 #include <async.h>
 #include <errno.h>
-#include <err.h>
 #include <ipc/ipc.h>
 #include <ipc/packet.h>
@@ -67,15 +66,22 @@
 packet_return(int phone, packet_ref packet, packet_id_t packet_id, size_t size)
 {
-	ERROR_DECLARE;
-	
 	ipc_call_t answer;
-	aid_t message = async_send_1(phone, NET_PACKET_GET, packet_id, &answer);
+	aid_t message;
+	int rc;
+	
+	message = async_send_1(phone, NET_PACKET_GET, packet_id, &answer);
 
 	*packet = (packet_t) as_get_mappable_page(size);
-	if (ERROR_OCCURRED(async_share_in_start_0_0(phone, *packet, size)) ||
-	    ERROR_OCCURRED(pm_add(*packet))) {
+	rc = async_share_in_start_0_0(phone, *packet, size);
+	if (rc != EOK) {
 		munmap(*packet, size);
 		async_wait_for(message, NULL);
-		return ERROR_CODE;
+		return rc;
+	}
+	rc = pm_add(*packet);
+	if (rc != EOK) {
+		munmap(*packet, size);
+		async_wait_for(message, NULL);
+		return rc;
 	}
 	
@@ -103,5 +109,5 @@
 int packet_translate_remote(int phone, packet_ref packet, packet_id_t packet_id)
 {
-	ERROR_DECLARE;
+	int rc;
 	
 	if (!packet)
@@ -112,7 +118,11 @@
 		ipcarg_t size;
 		
-		ERROR_PROPAGATE(async_req_1_1(phone, NET_PACKET_GET_SIZE,
-		    packet_id, &size));
-		ERROR_PROPAGATE(packet_return(phone, packet, packet_id, size));
+		rc = async_req_1_1(phone, NET_PACKET_GET_SIZE, packet_id,
+		    &size);
+		if (rc != EOK)
+			return rc;
+		rc = packet_return(phone, packet, packet_id, size);
+		if (rc != EOK)
+			return rc;
 	}
 	if ((*packet)->next) {
@@ -141,11 +151,11 @@
     size_t max_prefix, size_t max_suffix)
 {
-	ERROR_DECLARE;
-	
 	ipcarg_t packet_id;
 	ipcarg_t size;
-	
-	if (ERROR_OCCURRED(async_req_4_2(phone, NET_PACKET_CREATE_4,
-	    max_content, addr_len, max_prefix, max_suffix, &packet_id, &size)))
+	int rc;
+	
+	rc = async_req_4_2(phone, NET_PACKET_CREATE_4, max_content, addr_len,
+	    max_prefix, max_suffix, &packet_id, &size);
+	if (rc != EOK)
 		return NULL;
 	
@@ -153,6 +163,6 @@
 	packet_t packet = pm_find(packet_id);
 	if (!packet) {
-		if (ERROR_OCCURRED(packet_return(phone, &packet, packet_id,
-		    size)))
+		rc = packet_return(phone, &packet, packet_id, size);
+		if (rc != EOK)
 			return NULL;
 	}
@@ -172,17 +182,17 @@
 packet_t packet_get_1_remote(int phone, size_t content)
 {
-	ERROR_DECLARE;
-	
 	ipcarg_t packet_id;
 	ipcarg_t size;
-	
-	if (ERROR_OCCURRED(async_req_1_2(phone, NET_PACKET_CREATE_1, content,
-	    &packet_id, &size)))
+	int rc;
+	
+	rc = async_req_1_2(phone, NET_PACKET_CREATE_1, content, &packet_id,
+	    &size);
+	if (rc != EOK)
 		return NULL;
 	
 	packet_t packet = pm_find(packet_id);
 	if (!packet) {
-		if (ERROR_OCCURRED(packet_return(phone, &packet, packet_id,
-		    size)))
+		rc = packet_return(phone, &packet, packet_id, size);
+		if (rc != EOK)
 			return NULL;
 	}
Index: uspace/lib/net/netif/netif_local.c
===================================================================
--- uspace/lib/net/netif/netif_local.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/net/netif/netif_local.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -43,5 +43,5 @@
 #include <ipc/services.h>
 #include <ipc/netif.h>
-#include <err.h>
+#include <errno.h>
 
 #include <generic.h>
@@ -113,12 +113,13 @@
 int netif_start_req_local(int netif_phone, device_id_t device_id)
 {
-	ERROR_DECLARE;
+	int rc;
 	
 	fibril_rwlock_write_lock(&netif_globals.lock);
 	
 	netif_device_t *device;
-	if (ERROR_OCCURRED(find_device(device_id, &device))) {
+	rc = find_device(device_id, &device);
+	if (rc != EOK) {
 		fibril_rwlock_write_unlock(&netif_globals.lock);
-		return ERROR_CODE;
+		return rc;
 	}
 	
@@ -148,12 +149,13 @@
 int netif_stop_req_local(int netif_phone, device_id_t device_id)
 {
-	ERROR_DECLARE;
+	int rc;
 	
 	fibril_rwlock_write_lock(&netif_globals.lock);
 	
 	netif_device_t *device;
-	if (ERROR_OCCURRED(find_device(device_id, &device))) {
+	rc = find_device(device_id, &device);
+	if (rc != EOK) {
 		fibril_rwlock_write_unlock(&netif_globals.lock);
-		return ERROR_CODE;
+		return rc;
 	}
 	
@@ -203,5 +205,5 @@
     measured_string_ref *address, char **data)
 {
-	ERROR_DECLARE;
+	int rc;
 	
 	if (!address || !data)
@@ -211,7 +213,8 @@
 	
 	measured_string_t translation;
-	if (!ERROR_OCCURRED(netif_get_addr_message(device_id, &translation))) {
+	rc = netif_get_addr_message(device_id, &translation);
+	if (rc == EOK) {
 		*address = measured_string_copy(&translation);
-		ERROR_CODE = (*address) ? EOK : ENOMEM;
+		rc = (*address) ? EOK : ENOMEM;
 	}
 	
@@ -220,5 +223,5 @@
 	*data = (**address).value;
 	
-	return ERROR_CODE;
+	return rc;
 }
 
@@ -264,5 +267,5 @@
 int netif_init_module(async_client_conn_t client_connection)
 {
-	ERROR_DECLARE;
+	int rc;
 	
 	async_set_client_connection(client_connection);
@@ -271,10 +274,14 @@
 	netif_device_map_initialize(&netif_globals.device_map);
 	
-	ERROR_PROPAGATE(pm_init());
+	rc = pm_init();
+	if (rc != EOK)
+		return rc;
 	
 	fibril_rwlock_initialize(&netif_globals.lock);
-	if (ERROR_OCCURRED(netif_initialize())) {
+	
+	rc = netif_initialize();
+	if (rc != EOK) {
 		pm_destroy();
-		return ERROR_CODE;
+		return rc;
 	}
 	
@@ -317,9 +324,12 @@
 static int register_message(const char *name, device_id_t device_id, int phone)
 {
-	ERROR_DECLARE;
-	
 	netif_device_t *device;
-	ERROR_PROPAGATE(find_device(device_id, &device));
-	if(device->nil_phone > 0)
+	int rc;
+	
+	rc = find_device(device_id, &device);
+	if (rc != EOK)
+		return rc;
+	
+	if (device->nil_phone > 0)
 		return ELIMIT;
 	
@@ -349,10 +359,9 @@
     ipc_call_t *call, ipc_call_t *answer, int *answer_count)
 {
-	ERROR_DECLARE;
-	
 	size_t length;
 	device_stats_t stats;
 	packet_t packet;
 	measured_string_t address;
+	int rc;
 	
 	*answer_count = 0;
@@ -367,15 +376,17 @@
 	case IPC_M_CONNECT_TO_ME:
 		fibril_rwlock_write_lock(&netif_globals.lock);
-		ERROR_CODE = register_message(name, IPC_GET_DEVICE(call),
+		rc = register_message(name, IPC_GET_DEVICE(call),
 		    IPC_GET_PHONE(call));
 		fibril_rwlock_write_unlock(&netif_globals.lock);
-		return ERROR_CODE;
+		return rc;
 		
 	case NET_NETIF_SEND:
-		ERROR_PROPAGATE(packet_translate_remote(netif_globals.net_phone,
-		    &packet, IPC_GET_PACKET(call)));
+		rc = packet_translate_remote(netif_globals.net_phone, &packet,
+		    IPC_GET_PACKET(call));
+		if (rc != EOK)
+			return rc;
 		return netif_send_msg_local(0, IPC_GET_DEVICE(call), packet,
 		    IPC_GET_SENDER(call));
-		    
+		
 	case NET_NETIF_START:
 		return netif_start_req_local(0, IPC_GET_DEVICE(call));
@@ -384,7 +395,8 @@
 		fibril_rwlock_read_lock(&netif_globals.lock);
 
-		if (ERROR_OCCURRED(async_data_read_receive(&callid, &length))) {
+		rc = async_data_read_receive(&callid, &length);
+		if (rc != EOK) {
 			fibril_rwlock_read_unlock(&netif_globals.lock);
-			return ERROR_CODE;
+			return rc;
 		}
 		if (length < sizeof(device_stats_t)) {
@@ -393,12 +405,12 @@
 		}
 
-		if (ERROR_NONE(netif_get_device_stats(IPC_GET_DEVICE(call),
-		    &stats))) {
-			ERROR_CODE = async_data_read_finalize(callid, &stats,
+		rc = netif_get_device_stats(IPC_GET_DEVICE(call), &stats);
+		if (rc == EOK) {
+			rc = async_data_read_finalize(callid, &stats,
 			    sizeof(device_stats_t));
 		}
 
 		fibril_rwlock_read_unlock(&netif_globals.lock);
-		return ERROR_CODE;
+		return rc;
 
 	case NET_NETIF_STOP:
@@ -407,9 +419,9 @@
 	case NET_NETIF_GET_ADDR:
 		fibril_rwlock_read_lock(&netif_globals.lock);
-		if (ERROR_NONE(netif_get_addr_message(IPC_GET_DEVICE(call),
-		    &address)))
-			ERROR_CODE = measured_strings_reply(&address, 1);
+		rc = netif_get_addr_message(IPC_GET_DEVICE(call), &address);
+		if (rc == EOK)
+			rc = measured_strings_reply(&address, 1);
 		fibril_rwlock_read_unlock(&netif_globals.lock);
-		return ERROR_CODE;
+		return rc;
 	}
 	
@@ -431,7 +443,9 @@
 int netif_module_start_standalone(async_client_conn_t client_connection)
 {
-	ERROR_DECLARE;
-	
-	ERROR_PROPAGATE(netif_init_module(client_connection));
+	int rc;
+	
+	rc = netif_init_module(client_connection);
+	if (rc != EOK)
+		return rc;
 	
 	async_manager();
Index: uspace/lib/net/tl/socket_core.c
===================================================================
--- uspace/lib/net/tl/socket_core.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/net/tl/socket_core.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -48,5 +48,4 @@
 #include <stdlib.h>
 #include <errno.h>
-#include <err.h>
 
 #include <adt/dynamic_fifo.h>
@@ -164,7 +163,6 @@
     const char *key, size_t key_length)
 {
-	ERROR_DECLARE;
-
 	socket_core_ref *socket_ref;
+	int rc;
 
 	// create a wrapper
@@ -175,8 +173,9 @@
 	*socket_ref = socket;
 	// add the wrapper
-	if (ERROR_OCCURRED(socket_port_map_add(&socket_port->map, key,
-	    key_length, socket_ref))) {
+	rc = socket_port_map_add(&socket_port->map, key, key_length,
+	    socket_ref);
+	if (rc != EOK) {
 		free(socket_ref);
-		return ERROR_CODE;
+		return rc;
 	}
 	
@@ -204,7 +203,6 @@
     int port)
 {
-	ERROR_DECLARE;
-
 	socket_port_ref socket_port;
+	int rc;
 
 	// create a wrapper
@@ -214,22 +212,26 @@
 
 	socket_port->count = 0;
-	if (ERROR_OCCURRED(socket_port_map_initialize(&socket_port->map)) ||
-	    ERROR_OCCURRED(socket_port_add_core(socket_port, socket,
-	    SOCKET_MAP_KEY_LISTENING, 0))) {
-		socket_port_map_destroy(&socket_port->map);
-		free(socket_port);
-		return ERROR_CODE;
-	}
+	rc = socket_port_map_initialize(&socket_port->map);
+	if (rc != EOK)
+		goto fail;
+	
+	rc = socket_port_add_core(socket_port, socket, SOCKET_MAP_KEY_LISTENING,
+	    0);
+	if (rc != EOK)
+		goto fail;
 	
 	// register the incomming port
-	ERROR_CODE = socket_ports_add(global_sockets, port, socket_port);
-	if (ERROR_CODE < 0) {
-		socket_port_map_destroy(&socket_port->map);
-		free(socket_port);
-		return ERROR_CODE;
-	}
+	rc = socket_ports_add(global_sockets, port, socket_port);
+	if (rc < 0)
+		goto fail;
 	
 	socket->port = port;
 	return EOK;
+
+fail:
+	socket_port_map_destroy(&socket_port->map);
+	free(socket_port);
+	return rc;
+	
 }
 
@@ -416,9 +418,7 @@
     void *specific_data, int *socket_id)
 {
-	ERROR_DECLARE;
-
 	socket_core_ref socket;
-	int res;
 	int positive;
+	int rc;
 
 	if (!socket_id)
@@ -447,22 +447,23 @@
 	socket->key_length = 0;
 	socket->specific_data = specific_data;
-	if (ERROR_OCCURRED(dyn_fifo_initialize(&socket->received,
-	    SOCKET_INITIAL_RECEIVED_SIZE))) {
+	rc = dyn_fifo_initialize(&socket->received, SOCKET_INITIAL_RECEIVED_SIZE);
+	if (rc != EOK) {
 		free(socket);
-		return ERROR_CODE;
-	}
-	if (ERROR_OCCURRED(dyn_fifo_initialize(&socket->accepted,
-	    SOCKET_INITIAL_ACCEPTED_SIZE))) {
+		return rc;
+	}
+	
+	rc = dyn_fifo_initialize(&socket->accepted, SOCKET_INITIAL_ACCEPTED_SIZE);
+	if (rc != EOK) {
 		dyn_fifo_destroy(&socket->received);
 		free(socket);
-		return ERROR_CODE;
+		return rc;
 	}
 	socket->socket_id = *socket_id;
-	res = socket_cores_add(local_sockets, socket->socket_id, socket);
-	if (res < 0) {
+	rc = socket_cores_add(local_sockets, socket->socket_id, socket);
+	if (rc < 0) {
 		dyn_fifo_destroy(&socket->received);
 		dyn_fifo_destroy(&socket->accepted);
 		free(socket);
-		return res;
+		return rc;
 	}
 	
@@ -523,10 +524,9 @@
 int socket_reply_packets(packet_t packet, size_t *length)
 {
-	ERROR_DECLARE;
-
 	packet_t next_packet;
 	size_t fragments;
 	size_t *lengths;
 	size_t index;
+	int rc;
 
 	if (!length)
@@ -536,6 +536,8 @@
 	if (!next_packet) {
 		// write all if only one fragment
-		ERROR_PROPAGATE(data_reply(packet_get_data(packet),
-		    packet_get_data_length(packet)));
+		rc = data_reply(packet_get_data(packet),
+		    packet_get_data_length(packet));
+		if (rc != EOK)
+			return rc;
 		// store the total length
 		*length = packet_get_data_length(packet);
@@ -564,8 +566,8 @@
 		
 		// write the fragment lengths
-		if (ERROR_OCCURRED(data_reply(lengths,
-		    sizeof(int) * (fragments + 1)))) {
+		rc = data_reply(lengths, sizeof(int) * (fragments + 1));
+		if (rc != EOK) {
 			free(lengths);
-			return ERROR_CODE;
+			return rc;
 		}
 		next_packet = packet;
@@ -573,9 +575,9 @@
 		// write the fragments
 		for (index = 0; index < fragments; ++index) {
-			ERROR_CODE = data_reply(packet_get_data(next_packet),
+			rc = data_reply(packet_get_data(next_packet),
 			    lengths[index]);
-			if (ERROR_OCCURRED(ERROR_CODE)) {
+			if (rc != EOK) {
 				free(lengths);
-				return ERROR_CODE;
+				return rc;
 			}
 			next_packet = pq_next(next_packet);
@@ -680,7 +682,6 @@
     socket_core_ref socket, const char *key, size_t key_length)
 {
-	ERROR_DECLARE;
-
 	socket_port_ref socket_port;
+	int rc;
 
 	// find ports
@@ -690,6 +691,7 @@
 	
 	// add the socket
-	ERROR_PROPAGATE(socket_port_add_core(socket_port, socket, key,
-	    key_length));
+	rc = socket_port_add_core(socket_port, socket, key, key_length);
+	if (rc != EOK)
+		return rc;
 	
 	socket->port = port;
Index: uspace/lib/net/tl/tl_common.c
===================================================================
--- uspace/lib/net/tl/tl_common.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/net/tl/tl_common.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -54,5 +54,4 @@
 #include <ipc/services.h>
 #include <errno.h>
-#include <err.h>
 
 DEVICE_MAP_IMPLEMENT(packet_dimensions, packet_dimension_t);
@@ -124,5 +123,5 @@
     packet_dimension_ref *packet_dimension)
 {
-	ERROR_DECLARE;
+	int rc;
 	
 	if (!packet_dimension)
@@ -137,15 +136,15 @@
 			return ENOMEM;
 		
-		if (ERROR_OCCURRED(ip_packet_size_req(ip_phone, device_id,
-		    *packet_dimension))) {
+		rc = ip_packet_size_req(ip_phone, device_id, *packet_dimension);
+		if (rc != EOK) {
 			free(*packet_dimension);
-			return ERROR_CODE;
+			return rc;
 		}
 		
-		ERROR_CODE = packet_dimensions_add(packet_dimensions, device_id,
+		rc = packet_dimensions_add(packet_dimensions, device_id,
 		    *packet_dimension);
-		if (ERROR_CODE < 0) {
+		if (rc < 0) {
 			free(*packet_dimension);
-			return ERROR_CODE;
+			return rc;
 		}
 	}
@@ -292,9 +291,8 @@
     socklen_t addrlen)
 {
-	ERROR_DECLARE;
-
 	ipc_callid_t callid;
 	size_t length;
-	void * data;
+	void *data;
+	int rc;
 
 	if (!dimension)
@@ -319,10 +317,15 @@
 
 	// read the data into the packet
-	if (ERROR_OCCURRED(async_data_write_finalize(callid, data, length)) ||
-	    // set the packet destination address
-	    ERROR_OCCURRED(packet_set_addr(*packet, NULL, (uint8_t *) addr,
-	    addrlen))) {
+	rc = async_data_write_finalize(callid, data, length);
+	if (rc != EOK) {
 		pq_release_remote(packet_phone, packet_get_id(*packet));
-		return ERROR_CODE;
+		return rc;
+	}
+	
+	// set the packet destination address
+	rc = packet_set_addr(*packet, NULL, (uint8_t *) addr, addrlen);
+	if (rc != EOK) {
+		pq_release_remote(packet_phone, packet_get_id(*packet));
+		return rc;
 	}
 
Index: uspace/lib/packet/generic/packet_server.c
===================================================================
--- uspace/lib/packet/generic/packet_server.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/packet/generic/packet_server.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -42,5 +42,4 @@
 #include <async.h>
 #include <errno.h>
-#include <err.h>
 #include <fibril_synch.h>
 #include <unistd.h>
@@ -162,7 +161,6 @@
     size_t max_content, size_t max_suffix)
 {
-	ERROR_DECLARE;
-
 	packet_t packet;
+	int rc;
 
 	// already locked
@@ -177,5 +175,6 @@
 	packet_init(packet, addr_len, max_prefix, max_content, max_suffix);
 	packet->magic_value = PACKET_MAGIC_VALUE;
-	if (ERROR_OCCURRED(pm_add(packet))) {
+	rc = pm_add(packet);
+	if (rc != EOK) {
 		munmap(packet, packet->length);
 		return NULL;
Index: uspace/srv/bd/ata_bd/ata_bd.c
===================================================================
--- uspace/srv/bd/ata_bd/ata_bd.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/srv/bd/ata_bd/ata_bd.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -139,5 +139,5 @@
 		
 		snprintf(name, 16, "%s/disk%d", NAMESPACE, i);
-		rc = devmap_device_register(name, &disk[i].dev_handle);
+		rc = devmap_device_register(name, &disk[i].devmap_handle);
 		if (rc != EOK) {
 			devmap_hangup_phone(DEVMAP_DRIVER);
@@ -229,5 +229,5 @@
 	ipc_call_t call;
 	ipcarg_t method;
-	dev_handle_t dh;
+	devmap_handle_t dh;
 	int flags;
 	int retval;
@@ -242,5 +242,5 @@
 	disk_id = -1;
 	for (i = 0; i < MAX_DISKS; i++)
-		if (disk[i].dev_handle == dh)
+		if (disk[i].devmap_handle == dh)
 			disk_id = i;
 
